// openFTP
// Author Nilesh Bansal <nilesh@iitb.ac.in>


window.addEventListener("load", initOverlayopenFTP, false);

function initOverlayopenFTP(e) {
	checkValidity();
	var menu = document.getElementById("contentAreaContextMenu");
	try{
		menu.addEventListener("popupshowing", contextPopupshowingopenFTP, false);
	}catch(e){
		alert("Error in adding init overlays: "+e);
	}
}

function contextPopupshowingopenFTP(e) {
        document.getElementById("openftp").hidden= false;
	if(gContextMenu) {
		try{
			var href = gContextMenu.linkURL();
		}catch(e){
			disableopenFTPMenu();
			return;
		}
		if(href.substr(0, 6).toLowerCase() != "ftp://"){
			disableopenFTPMenu();
			return;
		}
	}else{
		disableopenFTPMenu();
	}
	return;
}

function disableopenFTPMenu(){
        document.getElementById("openftp").hidden= true;
}

function existsFile(path){
	var f = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	try{
		f.initWithPath(path);
	}catch(e){
		return (false);
	}
	if (f.exists())
		return (true);
	else
		return (false);
}

function searchPath(txt){
	var path = new Array(8);
	path[0] = '/usr/bin/';
	path[1] = '/opt/gnome/bin/';
	path[2] = '/usr/local/bin/';
	path[3] = '/bin/';
	path[4] = '/opt/kde3/bin/';
	path[5] = '/opt/kde/bin/';
	path[6] = "C:\\Program Files\\FileZilla\\";
	path[7] = "C:\\Program Files\\SmartFTP\\";
	var i;
	for(i in path){
		str = path[i];
		if(existsFile(str+txt))
			return (str+txt);	
	}
	return "undefined";
}

function openftp(txt) {
	if(gContextMenu) {
		try{
			var href = gContextMenu.linkURL();
		}catch(e){
			alert("Not a FTP link:");
		}

		if(href.substr(0, 6).toLowerCase() != "ftp://"){
			alert("Not a FTP link");
			return;
		}

		var cantMessage = "ERROR";

		try{
			var usePath = searchPath(txt);
			if(usePath == "undefined"){
				alert(txt+" executable not found");
				return;
			}
			var targetFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
			try{
				targetFile.initWithPath(usePath);
			}catch(e){
				alert("Failed to init targetFile: " + e);
			}
			if (! targetFile.exists()){
				alert(cantMessage);
				return(false);
			}
			try{
				var process = Components.classes['@mozilla.org/process/util;1'].getService(Components.interfaces.nsIProcess);
			}catch(e){                               
				alert("Failed to create process: " + e);  
			}
			try{
				process.init(targetFile);
			}catch(e){
				alert("Failed to init process: " + e);
			}
			try{
				var arguments= [] ;
				arguments.push(href);
			}catch(e){
				alert("Failed to push arguments: " + e);
			}
			try{
				process.run(false, arguments, arguments.length, {});
			}catch(e){
				alert("Failed to run process: " + e);
			}
			return true;
		}catch(e){
			alert("Failed: "+ e);
		}


	}else{
		alert("Open FTP: gContextMenu not defined");
	}
}

function checkValidity(){
	var programs = new Array(4);
	programs[0] = 'gftp';
	programs[1] = 'konqueror';
	programs[2] = 'Filezilla.exe';
	programs[3] = 'SmartFTP.exe';
	var j;
        for(j in programs){
                prgstr = programs[j];
                if(searchPath(prgstr) == 'undefined'){
                        try{
				var docid = "openftp-"+prgstr;
				document.getElementById(docid).hidden= true;	
			//	alert("disabled "+str);	
			}catch(e){
				alert(e);
			}
		}else{
		//		alert("kept "+prgstr);
		}
        }	
}
